QGIS Application - Feature request #9373
Support for UDP connections in GPS Widget
2014-01-20 12:12 AM - jtornero -

Status: Open

Priority: Normal

Assignee:

Category: Unknown

Pull Request or Patch supplied: Resolution:

Easy fix?: No Copied to github as #: 17973
Description

Sometimes NMEA data (not only GPS but sounders, etc) data is feeded through UDP datagrams. This is common, for instance, in
research vessels.

It would be nice for QGIS' GPS panel to have an option for UDP connections.

Best regards

History

#1 - 2014-01-20 02:03 AM - Jiirgen Fischer

Could you include pointers to any specs please?

#2 - 2014-01-20 02:25 AM - jtornero -

Hello,

What kind of specs should be needed (ports, hosts...?

AFAIK It depends a lot on the R/V, but basically the most widespread schema is to send UDP datagrams with the same format as a NMEA sentence; In
fact, what they do is a just a multiplexation of different instruments through the net. You can catch them simply listening to UDP datagrams at a given port.
Those datagrams can be catched by any computer on the net, so | guess an UDP broadcast/multicast is sent.

Jurgen Fischer wrote:

Could you include pointers to any specs please?

#3 - 2014-01-21 05:50 AM - jtornero -

Well, this is what I've made so far, maybe someone can take a look at it (sorry about coding, I'm not a C++ guy):

https://github.com/jtornero/QGIS/tree/UDP_GPS_Support

Basically:

1. Created a new class+files(cpp+h) called QgsGpsUdpConnection, which basically mimicks QgsGpsdConnection.
https://github.com/jtornero/QGIS/tree/UDP_GPS_Support

2. Made some changes to the GUI (radioButton for UDP plus configuration (port and host so far) lineEdits, plus one checkButton (to possibily add

broadcast/multicast if needed, currently figuring out how UDP GPS works)
3. Added logic for managing UDP radioButton in ggsgpsinformationwidget.cpp, which also mimicks the behaviour for GPSD radioButton

3. Added logic for management of UDP connection in qgsgpsdetector.cpp, in the same way than the GPSD connection is managed but creating a

QgsQGpsUdpConnection instead of a QgsGpsdConnection. (some parameters are passed to the udp connection but not used yet.
Success degree so far: Well, coding some debug strings mostly in ggsnmeaconnection.cpp:

src/core/gps/qgsgpsdetector.cpp: 169: (advance) Conexion UDP
src/core/gps/qgsgpsudpconnection.cpp: 33: (QgsGpsUdpConnection) [7]
src/core/gps/qgsgpsudpconnection.cpp: 34: (QgsGpsUdpConnection) localhost
src/core/gps/ggsnmeaconnection.cpp: 62: (parseData) numBytes:67
src/core/gps/ggsnmeaconnection.cpp: 75: (parseData) endSentencelndex is -1
src/core/gps/ggsnmeaconnection.cpp: 76: (parseData) dollarindex is -1
src/core/gps/ggsnmeaconnection.cpp: 77: (parseData) mStringBuffer length is 0
src/core/gps/ggsnmeaconnection.cpp: 78: (parseData) Firstchar is
src/core/gps/ggsnmeaconnection.cpp: 92: (processStringBuffer) endSentencelndex is -1
src/core/gps/ggsnmeaconnection.cpp: 93: (processStringBuffer) dollarindex is -1
src/core/gps/ggsnmeaconnection.cpp: 94: (processStringBuffer) mStringBuffer length is 0

src/core/gps/qgsgpsudpconnection.cpp: 41: (~QgsGpsUdpConnection) entered.

Seeing this homemade debug dump | think | can say:

1. The overall proccess works because | get bytes (67) when the GUI is properly configured, in my case, with port 5002. When | configure another port, no
bytes are received/read

2. But I'm not able to put that data into mStringBuffer. So after that, the call to processStringBuffer(); doesn't work and it happens that QGIS thinks that the
connection canit be stablished.

3. I suspect that it has to do with the way UDP is read, but can't be sure. I'm stuck here, but still trying to solve. Any help would be appreciated
Best regards

Jorge Tornero

#4 - 2014-01-25 10:53 AM - jtornero -
Dear all:

I've made a PR #1112 regarding to this issue. | hope that everything is OK, but | have some doubts with the code and how it works (mainly regarding to
QgsGpsDetector class).

Anyway, the patch makes it work as expected: QGIS is now able to listen to an UDP port and get broadcasted NMEA sentences.

Despite this is my initial patch and maybe (well... for sure) it need some refinement, | want to thank to all the people who has been so patient with me in
these days with this stuff and related (git et Al.)

Best regards
Jorge Tornero

#5 - 2014-01-25 10:57 AM - Giovanni Manghi

- Category set to C++ Plugins

- Pull Request or Patch supplied changed from No to Yes
- Target version set to Future Release - Nice to have

#6 - 2014-03-26 11:34 AM - Alexander Bruy
- Category deleted (C++ Plugins)

#7 - 2017-05-01 12:48 AM - Giovanni Manghi
- Easy fix? set to No

#8 - 2017-09-22 10:07 AM - Jiirgen Fischer

- Category set to Unknown
